"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _redux = require("redux");

var _reactRedux = require("react-redux");

var _devui = require("devui");

var _actions = require("../../actions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var defaultSchema = {
  type: 'object',
  required: [],
  properties: {
    type: {
      title: 'Connection settings (for getting reports and remote debugging)',
      type: 'string',
      "enum": ['disabled', 'remotedev', 'custom'],
      enumNames: ['no remote connection', 'connect via remotedev.io', 'use local (custom) server']
    },
    hostname: {
      type: 'string'
    },
    port: {
      type: 'number'
    },
    secure: {
      type: 'boolean'
    }
  }
};
var uiSchema = {
  type: {
    'ui:widget': 'radio'
  }
};

var Connection = /*#__PURE__*/function (_Component) {
  _inherits(Connection, _Component);

  var _super = _createSuper(Connection);

  function Connection(props) {
    var _this;

    _classCallCheck(this, Connection);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "handleSave", function (data) {
      _this.props.saveSettings(data.formData);

      _this.setState({
        changed: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "setFormData", function (type, changed) {
      var schema;

      if (type !== 'custom') {
        schema = {
          type: 'object',
          properties: {
            type: defaultSchema.properties.type
          }
        };
      } else {
        schema = defaultSchema;
      }

      return {
        formData: _objectSpread({
          type: type
        }, _this.props.options),
        type: type,
        schema: schema,
        changed: changed
      };
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (data) {
      var formData = data.formData;
      var type = formData.type;

      if (type !== _this.state.type) {
        _this.setState(_this.setFormData(type, true));
      } else if (!_this.state.changed) {
        _this.setState({
          changed: true,
          formData: formData
        });
      }
    });

    _this.state = _this.setFormData(props.type);
    return _this;
  }

  _createClass(Connection, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return this.state !== nextState;
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (this.props.options !== nextProps.options) {
        this.setState({
          formData: _objectSpread(_objectSpread({}, nextProps.options), {}, {
            type: nextProps.type
          })
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var type = this.state.type || 'disabled';
      var changed = this.state.changed;
      var disabled = type === 'disabled';
      return /*#__PURE__*/_react["default"].createElement(_devui.Container, null, /*#__PURE__*/_react["default"].createElement(_devui.Form, {
        primaryButton: changed,
        noSubmit: disabled && !changed,
        submitText: disabled ? 'Disconnect' : 'Connect',
        formData: this.state.formData,
        schema: this.state.schema,
        uiSchema: uiSchema,
        onChange: this.handleChange,
        onSubmit: this.handleSave
      }));
    }
  }]);

  return Connection;
}(_react.Component);

_defineProperty(Connection, "propTypes", {
  saveSettings: _propTypes["default"].func.isRequired,
  options: _propTypes["default"].object.isRequired,
  type: _propTypes["default"].string
});

function mapStateToProps(state) {
  return state.connection;
}

function mapDispatchToProps(dispatch) {
  return {
    saveSettings: (0, _redux.bindActionCreators)(_actions.saveSocketSettings, dispatch)
  };
}

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Connection);

exports["default"] = _default;