"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reduxDevtoolsInstrument = require("redux-devtools-instrument");

var _devui = require("devui");

var _RecordButton = _interopRequireDefault(require("./buttons/RecordButton"));

var _PersistButton = _interopRequireDefault(require("./buttons/PersistButton"));

var _LockButton = _interopRequireDefault(require("./buttons/LockButton"));

var _InstanceSelector = _interopRequireDefault(require("./InstanceSelector"));

var _SyncButton = _interopRequireDefault(require("./buttons/SyncButton"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var reset = _reduxDevtoolsInstrument.ActionCreators.reset,
    rollback = _reduxDevtoolsInstrument.ActionCreators.rollback,
    commit = _reduxDevtoolsInstrument.ActionCreators.commit,
    sweep = _reduxDevtoolsInstrument.ActionCreators.sweep;

var TopButtons = /*#__PURE__*/function (_Component) {
  _inherits(TopButtons, _Component);

  var _super = _createSuper(TopButtons);

  function TopButtons() {
    var _this;

    _classCallCheck(this, TopButtons);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "handleRollback", function () {
      _this.props.dispatch(rollback());
    });

    _defineProperty(_assertThisInitialized(_this), "handleSweep", function () {
      _this.props.dispatch(sweep());
    });

    _defineProperty(_assertThisInitialized(_this), "handleCommit", function () {
      _this.props.dispatch(commit());
    });

    _defineProperty(_assertThisInitialized(_this), "handleReset", function () {
      _this.props.dispatch(reset());
    });

    return _this;
  }

  _createClass(TopButtons, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return nextProps.options !== this.props.options || nextProps.liftedState !== this.props.liftedState;
    }
  }, {
    key: "render",
    value: function render() {
      var options = this.props.options;
      var features = options.features;
      var _this$props$liftedSta = this.props.liftedState,
          computedStates = _this$props$liftedSta.computedStates,
          skippedActionIds = _this$props$liftedSta.skippedActionIds,
          isPaused = _this$props$liftedSta.isPaused,
          isLocked = _this$props$liftedSta.isLocked;
      var noStates = computedStates.length < 2;
      return /*#__PURE__*/_react["default"].createElement(_devui.Toolbar, {
        borderPosition: "bottom"
      }, features.pause && /*#__PURE__*/_react["default"].createElement(_RecordButton["default"], {
        paused: isPaused
      }), features.persist && /*#__PURE__*/_react["default"].createElement(_PersistButton["default"], null), features.lock && /*#__PURE__*/_react["default"].createElement(_LockButton["default"], {
        locked: isLocked,
        disabled: options.lib !== 'redux'
      }), /*#__PURE__*/_react["default"].createElement(_devui.Divider, null), /*#__PURE__*/_react["default"].createElement(_devui.Button, {
        title: "Reset to the state you created the store with",
        tooltipPosition: "bottom",
        onClick: this.handleReset
      }, "Reset"), /*#__PURE__*/_react["default"].createElement(_devui.Button, {
        title: "Roll back to the last committed state",
        tooltipPosition: "bottom",
        onClick: this.handleRollback,
        disabled: noStates
      }, "Revert"), /*#__PURE__*/_react["default"].createElement(_devui.Button, {
        title: "Remove all currently disabled actions from the log",
        tooltipPosition: "bottom",
        onClick: this.handleSweep,
        disabled: skippedActionIds.length === 0
      }, "Sweep"), /*#__PURE__*/_react["default"].createElement(_devui.Button, {
        title: "Remove all actions from the log,\\a and make the current state your initial state",
        tooltipPosition: "bottom",
        onClick: this.handleCommit,
        disabled: noStates
      }, "Commit"), /*#__PURE__*/_react["default"].createElement(_devui.Divider, null), /*#__PURE__*/_react["default"].createElement(_InstanceSelector["default"], null), features.sync && /*#__PURE__*/_react["default"].createElement(_SyncButton["default"], null));
    }
  }]);

  return TopButtons;
}(_react.Component);

exports["default"] = TopButtons;

_defineProperty(TopButtons, "propTypes", {
  // shouldSync: PropTypes.bool,
  liftedState: _propTypes["default"].object.isRequired,
  dispatch: _propTypes["default"].func.isRequired,
  options: _propTypes["default"].object.isRequired
});