"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _redux = require("redux");

var _reactRedux = require("react-redux");

var _devui = require("devui");

var _Slider = _interopRequireDefault(require("./monitors/Slider"));

var _actions = require("../actions");

var _instances = require("../reducers/instances");

var _DevTools = _interopRequireDefault(require("../containers/DevTools"));

var _Dispatcher = _interopRequireDefault(require("./monitors/Dispatcher"));

var _TopButtons = _interopRequireDefault(require("../components/TopButtons"));

var _BottomButtons = _interopRequireDefault(require("../components/BottomButtons"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Actions = /*#__PURE__*/function (_Component) {
  _inherits(Actions, _Component);

  var _super = _createSuper(Actions);

  function Actions() {
    _classCallCheck(this, Actions);

    return _super.apply(this, arguments);
  }

  _createClass(Actions, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          monitor = _this$props.monitor,
          dispatcherIsOpen = _this$props.dispatcherIsOpen,
          sliderIsOpen = _this$props.sliderIsOpen,
          options = _this$props.options,
          liftedState = _this$props.liftedState,
          liftedDispatch = _this$props.liftedDispatch;
      return /*#__PURE__*/_react["default"].createElement(_devui.Container, null, /*#__PURE__*/_react["default"].createElement(_TopButtons["default"], {
        dispatch: liftedDispatch,
        liftedState: liftedState,
        options: options
      }), /*#__PURE__*/_react["default"].createElement(_DevTools["default"], {
        monitor: monitor,
        liftedState: liftedState,
        monitorState: this.props.monitorState,
        dispatch: liftedDispatch,
        features: options.features
      }), sliderIsOpen && options.connectionId && options.features.jump && /*#__PURE__*/_react["default"].createElement(_Slider["default"], {
        liftedState: liftedState,
        dispatch: liftedDispatch
      }), dispatcherIsOpen && options.connectionId && options.features.dispatch && /*#__PURE__*/_react["default"].createElement(_Dispatcher["default"], {
        options: options
      }), /*#__PURE__*/_react["default"].createElement(_BottomButtons["default"], {
        dispatcherIsOpen: dispatcherIsOpen,
        sliderIsOpen: sliderIsOpen,
        options: options
      }));
    }
  }]);

  return Actions;
}(_react.Component);

Actions.propTypes = {
  liftedDispatch: _propTypes["default"].func.isRequired,
  liftedState: _propTypes["default"].object.isRequired,
  monitorState: _propTypes["default"].object,
  options: _propTypes["default"].object.isRequired,
  monitor: _propTypes["default"].string,
  dispatcherIsOpen: _propTypes["default"].bool,
  sliderIsOpen: _propTypes["default"].bool
};

function mapStateToProps(state) {
  var instances = state.instances;
  var id = (0, _instances.getActiveInstance)(instances);
  return {
    liftedState: instances.states[id],
    monitorState: state.monitor.monitorState,
    options: instances.options[id],
    monitor: state.monitor.selected,
    dispatcherIsOpen: state.monitor.dispatcherIsOpen,
    sliderIsOpen: state.monitor.sliderIsOpen,
    reports: state.reports.data
  };
}

function mapDispatchToProps(dispatch) {
  return {
    liftedDispatch: (0, _redux.bindActionCreators)(_actions.liftedDispatch, dispatch),
    getReport: (0, _redux.bindActionCreators)(_actions.getReport, dispatch)
  };
}

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Actions);

exports["default"] = _default;