"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _redux = require("redux");

var _reactRedux = require("react-redux");

var _styledComponents = require("styled-components");

var _d3StateVisualizer = require("d3-state-visualizer");

var _ChartMonitorWrapper = require("../ChartMonitorWrapper");

var _actions = require("../../../actions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var style = {
  width: '100%',
  height: '100%'
};

var ChartTab = /*#__PURE__*/function (_Component) {
  _inherits(ChartTab, _Component);

  var _super = _createSuper(ChartTab);

  function ChartTab() {
    var _this;

    _classCallCheck(this, ChartTab);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "getRef", function (node) {
      _this.node = node;
    });

    _defineProperty(_assertThisInitialized(_this), "onClickText", function (data) {
      var inspectedStatePath = [];
      (0, _ChartMonitorWrapper.getPath)(data, inspectedStatePath);

      _this.props.updateMonitorState({
        inspectedStatePath: inspectedStatePath,
        subTabName: data.children ? 'Chart' : 'Tree'
      });
    });

    return _this;
  }

  _createClass(ChartTab, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      return false;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.createChart(this.props);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (this.props.theme.scheme !== nextProps.theme.scheme || nextProps.theme.light !== this.props.theme.light) {
        this.node.innerHTML = '';
        this.createChart(nextProps);
      } else if (nextProps.data !== this.props.data) {
        this.renderChart(nextProps.data);
      }
    }
  }, {
    key: "createChart",
    value: function createChart(props) {
      this.renderChart = (0, _d3StateVisualizer.tree)(this.node, this.getChartTheme(props.theme));
      this.renderChart(props.data);
    }
  }, {
    key: "getChartTheme",
    value: function getChartTheme(theme) {
      return {
        heightBetweenNodesCoeff: 1,
        widthBetweenNodesCoeff: 1.3,
        tooltipOptions: {
          style: {
            color: theme.base06,
            'background-color': theme.base01,
            opacity: '0.9',
            'border-radius': '5px',
            padding: '5px'
          },
          offset: {
            left: 30,
            top: 10
          },
          indentationSize: 2
        },
        style: {
          width: '100%',
          height: '100%',
          node: {
            colors: {
              "default": theme.base0B,
              collapsed: theme.base0B,
              parent: theme.base0E
            },
            radius: 7
          },
          text: {
            colors: {
              "default": theme.base0D,
              hover: theme.base06
            }
          }
        },
        onClickText: this.onClickText
      };
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react["default"].createElement("div", {
        style: style,
        ref: this.getRef
      });
    }
  }]);

  return ChartTab;
}(_react.Component);

ChartTab.propTypes = {
  data: _propTypes["default"].object,
  updateMonitorState: _propTypes["default"].func.isRequired,
  theme: _propTypes["default"].object.isRequired
};

function mapDispatchToProps(dispatch) {
  return {
    updateMonitorState: (0, _redux.bindActionCreators)(_actions.updateMonitorState, dispatch)
  };
}

var ConnectedChartTab = (0, _reactRedux.connect)(null, mapDispatchToProps)(ChartTab);

var _default = (0, _styledComponents.withTheme)(ConnectedChartTab);

exports["default"] = _default;