"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = commitExcessActions;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

// Based on https://github.com/gaearon/redux-devtools/pull/241

/* eslint-disable no-param-reassign */
function commitExcessActions(liftedState) {
  var n = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
  // Auto-commits n-number of excess actions.
  var excess = n;
  var idsToDelete = liftedState.stagedActionIds.slice(1, excess + 1);

  for (var i = 0; i < idsToDelete.length; i++) {
    if (liftedState.computedStates[i + 1].error) {
      // Stop if error is found. Commit actions up to error.
      excess = i;
      idsToDelete = liftedState.stagedActionIds.slice(1, excess + 1);
      break;
    } else {
      delete liftedState.actionsById[idsToDelete[i]];
    }
  }

  liftedState.skippedActionIds = liftedState.skippedActionIds.filter(function (id) {
    return idsToDelete.indexOf(id) === -1;
  });
  liftedState.stagedActionIds = [0].concat(_toConsumableArray(liftedState.stagedActionIds.slice(excess + 1)));
  liftedState.committedState = liftedState.computedStates[excess].state;
  liftedState.computedStates = liftedState.computedStates.slice(excess);
  liftedState.currentStateIndex = liftedState.currentStateIndex > excess ? liftedState.currentStateIndex - excess : 0;
}