"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = getMonitor;
exports.monitors = void 0;

var _react = _interopRequireDefault(require("react"));

var _reduxDevtoolsLogMonitor = _interopRequireDefault(require("redux-devtools-log-monitor"));

var _ChartMonitorWrapper = _interopRequireDefault(require("../containers/monitors/ChartMonitorWrapper"));

var _InspectorWrapper = _interopRequireDefault(require("../containers/monitors/InspectorWrapper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var monitors = [{
  value: 'InspectorMonitor',
  name: 'Inspector'
}, {
  value: 'LogMonitor',
  name: 'Log monitor'
}, {
  value: 'ChartMonitor',
  name: 'Chart'
}];
exports.monitors = monitors;

function getMonitor(_ref) {
  var monitor = _ref.monitor;

  switch (monitor) {
    case 'LogMonitor':
      return /*#__PURE__*/_react["default"].createElement(_reduxDevtoolsLogMonitor["default"], {
        preserveScrollTop: false,
        hideMainButtons: true,
        markStateDiff: true
      });

    case 'ChartMonitor':
      return /*#__PURE__*/_react["default"].createElement(_ChartMonitorWrapper["default"], null);

    default:
      return /*#__PURE__*/_react["default"].createElement(_InspectorWrapper["default"], null);
  }
}